#ifndef ERROR_H
#define ERROR_H

extern void ErrSetLogName(char *logfile);
#define ErrLog(x) _ErrLog(x,__FILE__,__LINE__) 
#define ErrWarning(x) _ErrWarning(x,__FILE__,__LINE__) 
#define ErrError(x) _ErrError(x,__FILE__,__LINE__) 
extern void _ErrLog(char *text, char *file, int line);
extern void _ErrWarning(char *text, char *file, int line);
extern void _ErrError(char *text, char *file, int line);


#if defined(DEBUG)
#define assert(test) ((test)?0:_assert(#test,__FILE__,__LINE__))
#define verify(op) ((op)?0:_verify(#op,__FILE__,__LINE__))
extern void _assert(char *test,char *file, int line);
extern void _verify(char *test,char *file, int line);
#else
#define assert(test) (void)0
#define verify(op) (op)
#endif

#endif /* ERROR_H */
