#ifndef ZOBJECT_H
#define ZOBJECT_H

#include <arch.h>

#define MAXDATADIM 4

enum ZObjTypes {
  TYPE_ZFLATPOLY,
  TYPE_ZGOROUDPOLY,
  TYPE_ZTEXTUREPOLY,
  TYPE_ZLINE,
  TYPE_ZDOT
};


struct ZObject {
  signed_32bit ZValue;
  unsigned_32bit ObjType;
  struct ZObject *next;
};

typedef struct ZObject ZObject;

struct ZFlatPoly {
  signed_32bit ZValue;
  unsigned_32bit ObjType;
  struct ZObject *next;
  byte ClockWise;
  byte Color;
  signed_32bit Intensity;
  signed_32bit Vertices[3*2]; /* (28.4 fixpoint) */
};
typedef struct ZFlatPoly ZFlatPoly;

struct ZGoroudPoly {
  signed_32bit ZValue;
  unsigned_32bit ObjType;
  struct ZObject *next;
  byte ClockWise;
  byte Color;
  signed_32bit Vertices[3*3]; /* (x,y,i) (28.4 & 16.16 fixpoint) */
};
typedef struct ZGoroudPoly ZGoroudPoly;

struct ZTexturePoly {
  signed_32bit ZValue;
  unsigned_32bit ObjType;
  struct ZObject *next;
  byte ClockWise;
  byte BitWidth;
  byte *Texture;
  signed_32bit Vertices[3*4]; /* (x,y,u,v) (28.4 & 16.16 fixpoint) */
};
typedef struct ZTexturePoly ZTexturePoly;

struct ZDot {
  signed_32bit ZValue;
  unsigned_32bit ObjType;
  struct ZObject *next;
  byte Color;
  signed_32bit Vertices[2]; /* (x,y) 28.4 */
};
typedef struct ZDot ZDot;

struct ZLine {
  signed_32bit ZValue;
  unsigned_32bit ObjType;
  struct ZObject *next;
  byte Color;
  signed_32bit Vertices[4]; /* (x,y)-(x,y) 28.4 */
};
typedef struct ZLine ZLine;

#endif /* ZOBJECT_H */
